Index: /trunk/examples/objects/xmlparser/xmlparser.cc
===================================================================
--- /trunk/examples/objects/xmlparser/xmlparser.cc	(revision 1559)
+++ /trunk/examples/objects/xmlparser/xmlparser.cc	(revision 1560)
@@ -1,199 +1,311 @@
-#include <stdio.h>
-#include <expat.h>
-#include <string.h>
-#include "RpInt.h"
-#include "RpChain.h"
-#include "RpPath.h"
-#include "RpNumber.h"
-
-#define BUFFSIZE        8192
-
-char Buff[BUFFSIZE];
-
-typedef struct {
-    int skip;
-    int depth;
-    Rappture::Path *path;
-    Rp_Chain *c;
-    void *lastObj;
-    int lastObjType;
-    Rappture::Object *v;
-} Parseinfo;
-
-void
-init_info(Parseinfo *info) {
-    info->skip = 0;
-    info->depth = 1;
-    info->path = new Rappture::Path();
-    info->c = Rp_ChainCreate();
-    info->lastObj = NULL;
-    info->lastObjType = 0;
-    info->v = NULL;
-}
-
-int
-should_skip(Parseinfo *inf, const char *el, const char **attr) {
-    int skip = 0;
-
-    if ( (*el == 's') && (strcmp("string",el) == 0) ) {
-        skip = 1;
-    }
-
-    return skip;
-}
-
-static void XMLCALL
-start(void *data, const char *el, const char **attr)
-{
-    Parseinfo *inf = (Parseinfo *) data;
-
-    if ( (*el == 'i') && (strcmp("input",el) == 0) ) {
-        inf->path->add(el);
-    } else if ( (*el == 'n') && (strcmp("number",el) == 0) ) {
-        inf->path->add(el);
-        // null units kills number
-        // Rappture::Number *n = new Rappture::Number(inf->path->path(NULL),NULL,0.0);
-        Rappture::Number *n = new Rappture::Number(inf->path->path(),"",0.0);
-        Rp_ChainAppend(inf->c,n);
-        inf->v = n;
-    } else {
-        // add the tags to the hash table of the last object we created.
-        // this means new objects must be declared here,
-        // or they will become part of the last recognized object
-        // this could lead to major problems.
-        // we have no way to ignore stuff we don't recognize
-
-        inf->path->add(el);
-        if (inf->v) {
-            // inf->v->property(el,);
-        }
-    }
-
-    inf->depth++;
-}
-
-static void XMLCALL
-end(void *data, const char *el)
-{
-    Parseinfo *inf = (Parseinfo *) data;
-    inf->path->del();
-    inf->depth--;
-    // pop object off the end of the inf->c chain
-    // add object to the tree object
-}
-
-void
-rawstart(void *data, const char *el, const char **attr) {
-    Parseinfo *inf = (Parseinfo *) data;
-
-    if (! inf->skip) {
-        if (should_skip(inf, el, attr)) {
-            inf->skip = inf->depth;
-        }
-        else {
-            start(inf, el, attr);     /* This does rest of start handling */
-        }
-    }
-
-    inf->depth++;
-}  /* End of rawstart */
-
-void
-rawend(void *data, const char *el) {
-    Parseinfo *inf = (Parseinfo *) data;
-
-    inf->depth--;
-
-    if (! inf->skip) {
-        end(inf, el);              /* This does rest of end handling */
-    }
-
-    if (inf->skip == inf->depth) {
-        inf->skip = 0;
-    }
-}  /* End rawend */
-
-/*
-void
-char_handler(void* data, XML_Char const* s, int len)
-{
-    int total = 0;
-    int total_old = 0;
-    scew_element* current = NULL;
-    Parseinfo *inf = (Parseinfo *) data;
-
-    if (inf == NULL) {
-        return;
-    }
-
-    if (inf->v == NULL)
-    {
-        return;
-    }
-
-    if (current->contents != NULL)
-    {
-        total_old = scew_strlen(current->contents);
-    }
-    total = (total_old + len + 1) * sizeof(XML_Char);
-    current->contents = (XML_Char*) realloc(current->contents, total);
-
-    if (total_old == 0)
-    {
-        current->contents[0] = '\0';
-    }
-
-    scew_strncat(current->contents, s, len);
-}
-*/
-
-
-int
-main(int argc, char *argv[])
-{
-    Parseinfo info;
-    XML_Parser p = XML_ParserCreate(NULL);
-    if (! p) {
-        fprintf(stderr, "Couldn't allocate memory for parser\n");
-        exit(-1);
-    }
-
-    init_info(&info);
-    XML_SetUserData(p,&info);
-
-    XML_SetElementHandler(p, rawstart, rawend);
-    //XML_SetDefaultHandler(p, char_handler);
-
-    for (;;) {
-        int done;
-        int len;
-
-        len = fread(Buff, 1, BUFFSIZE, stdin);
-        if (ferror(stdin)) {
-            fprintf(stderr, "Read error\n");
-            exit(-1);
-        }
-        done = feof(stdin);
-
-        if (XML_Parse(p, Buff, len, done) == XML_STATUS_ERROR) {
-            fprintf(stderr, "Parse error at line %lu:\n%s\n",
-                    XML_GetCurrentLineNumber(p),
-                    XML_ErrorString(XML_GetErrorCode(p)));
-            exit(-1);
-        }
-
-        if (done) {
-            break;
-        }
-    }
-
-    Rp_ChainLink *lv = NULL;
-    Rappture::Number *n = NULL;
-    lv = Rp_ChainFirstLink(info.c);
-    while (lv) {
-        n = (Rappture::Number *) Rp_ChainGetValue(lv);
-        printf("%s\n",n->xml());
-        lv = Rp_ChainNextLink(lv);
-    }
+#include <iostream>
+#include <errno.h>
+#include <fstream>
+#include <sys/stat.h>
+#include "RpParserXML.h"
+
+size_t
+readFile (
+    const char *filePath,
+    const char **buf)
+{
+    if (buf == NULL) {
+        fprintf(stderr,"buf is NULL while opening file \"%s\"", filePath);
+        return 0;
+    }
+
+    FILE *f;
+    f = fopen(filePath, "rb");
+    if (f == NULL) {
+        fprintf(stderr,"can't open \"%s\": %s", filePath, strerror(errno));
+        return 0;
+    }
+    struct stat stat;
+    if (fstat(fileno(f), &stat) < 0) {
+        fprintf(stderr,"can't stat \"%s\": %s", filePath, strerror(errno));
+        return 0;
+    }
+    off_t size;
+    size = stat.st_size;
+    char* memblock;
+    memblock = new char [size+1];
+    if (memblock == NULL) {
+        fprintf(stderr,"can't allocate %zu bytes for file \"%s\": %s",
+            size, filePath, strerror(errno));
+        fclose(f);
+        return 0;
+    }
+
+    size_t nRead;
+    nRead = fread(memblock, sizeof(char), size, f);
+    fclose(f);
+
+    if (nRead != (size_t)size) {
+        fprintf(stderr,"can't read %zu bytes from \"%s\": %s", size, filePath,
+            strerror(errno));
+        return 0;
+    }
+
+    memblock[size] = '\0';
+    *buf = memblock;
+    return nRead;
+}
+
+int xmlparser_0_0 ()
+{
+    const char *desc = "test creating xml parser";
+    const char *testname = "xmlparser_0_0";
+    int retVal = 0;
+
+    const char *expected = "initialized ParserXml Object";
+    const char *received = NULL;
+
+    Rp_ParserXml *p = NULL;
+
+    p = Rp_ParserXmlCreate();
+
+    if (p == NULL) {
+        printf("Error: %s\n", testname);
+        printf("\t%s\n", desc);
+        printf("\texpected \"%s\"\n",expected);
+        printf("\treceived \"%s\"\n",received);
+        retVal = 1;
+    }
+
+    if (p) {
+        Rp_ParserXmlDestroy(&p);
+    }
+
+    return retVal;
+}
+
+int xmlparser_1_0 ()
+{
+    const char *desc = "test sending xml text to xml parser";
+    const char *testname = "xmlparser_1_0";
+    const char *infile = "xmlparser_1_0_in.xml";
+    const char *outfile = "xmlparser_1_0_out.xml";
+    int retVal = 0;
+
+    const char *xmltext = NULL;
+    const char *expected = NULL;
+
+    readFile(infile,&xmltext);
+    readFile(outfile,&expected);
+
+    const char *received = NULL;
+
+    Rp_ParserXml *p = NULL;
+
+    p = Rp_ParserXmlCreate();
+
+    Rp_ParserXmlParse(p, xmltext);
+
+    received = Rp_ParserXmlXml(p);
+
+
+    if (strcmp(expected,received) != 0) {
+        printf("Error: %s\n", testname);
+        printf("\t%s\n", desc);
+        printf("\texpected %zu bytes: \"%s\"\n",strlen(expected), expected);
+        printf("\treceived %zu bytes: \"%s\"\n",strlen(received), received);
+        retVal = 1;
+    }
+
+    if (p) {
+        Rp_ParserXmlDestroy(&p);
+    }
+
+    return retVal;
+}
+
+
+int xmlparser_2_0 ()
+{
+    const char *desc = "test printing xml as path/val combos";
+    const char *testname = "xmlparser_2_0";
+    const char *infile = "xmlparser_2_0_in.xml";
+    int retVal = 0;
+
+    const char *xmltext = NULL;
+
+    readFile(infile,&xmltext);
+
+    const char *expected = "\
+run.tool.about Press Simulate to view results.\n\
+run.tool.command tclsh @tool/fermi.tcl @driver\n\
+run.input.number(Ef).about.label Fermi Level\n\
+run.input.number(Ef).about.description Energy at center of distribution.\n\
+run.input.number(Ef).units eV\n\
+run.input.number(Ef).min -10eV\n\
+run.input.number(Ef).max 10eV\n\
+run.input.number(Ef).default 0eV\n\
+run.input.number(Ef).current 0eV\n";
+
+    const char *received = NULL;
+
+    Rp_ParserXml *p = NULL;
+
+    p = Rp_ParserXmlCreate();
+
+    Rp_ParserXmlParse(p, xmltext);
+
+    received = Rp_ParserXmlPathVal(p);
+
+
+    if (strcmp(expected,received) != 0) {
+        printf("Error: %s\n", testname);
+        printf("\t%s\n", desc);
+        printf("\texpected %zu bytes: \"%s\"\n",strlen(expected), expected);
+        printf("\treceived %zu bytes: \"%s\"\n",strlen(received), received);
+        retVal = 1;
+    }
+
+    if (p) {
+        Rp_ParserXmlDestroy(&p);
+    }
+
+    return retVal;
+}
+
+int xmlparser_3_0 ()
+{
+    const char *desc = "test getting xml value";
+    const char *testname = "xmlparser_3_0";
+    const char *infile = "xmlparser_2_0_in.xml";
+    int retVal = 0;
+
+    const char *xmltext = NULL;
+
+    readFile(infile,&xmltext);
+
+    const char *expected = "0eV";
+
+    const char *received = NULL;
+
+    Rp_ParserXml *p = NULL;
+
+    p = Rp_ParserXmlCreate();
+
+    Rp_ParserXmlParse(p, xmltext);
+
+    received = Rp_ParserXmlGet(p,"input.number(Ef).current");
+
+
+    if (strcmp(expected,received) != 0) {
+        printf("Error: %s\n", testname);
+        printf("\t%s\n", desc);
+        printf("\texpected %zu bytes: \"%s\"\n",strlen(expected), expected);
+        printf("\treceived %zu bytes: \"%s\"\n",strlen(received), received);
+        retVal = 1;
+    }
+
+    if (p) {
+        Rp_ParserXmlDestroy(&p);
+    }
+
+    return retVal;
+}
+
+int xmlparser_4_0 ()
+{
+    const char *desc = "test putting xml value";
+    const char *testname = "xmlparser_4_0";
+    const char *infile = "xmlparser_2_0_in.xml";
+    int retVal = 0;
+
+    const char *xmltext = NULL;
+
+    readFile(infile,&xmltext);
+
+    const char *expected = "hi mom";
+
+    const char *received = NULL;
+
+    Rp_ParserXml *p = NULL;
+
+    p = Rp_ParserXmlCreate();
+
+    Rp_ParserXmlParse(p, xmltext);
+
+    Rp_ParserXmlPut(p,"input.number(gg).current","hi mom",0);
+    received = Rp_ParserXmlGet(p,"input.number(gg).current");
+
+    if (strcmp(expected,received) != 0) {
+        printf("Error: %s\n", testname);
+        printf("\t%s\n", desc);
+        printf("\texpected %zu bytes: \"%s\"\n",strlen(expected), expected);
+        printf("\treceived %zu bytes: \"%s\"\n",strlen(received), received);
+        retVal = 1;
+    }
+
+    if (p) {
+        Rp_ParserXmlDestroy(&p);
+    }
+
+    return retVal;
+}
+
+int xmlparser_5_0 ()
+{
+    const char *desc = "test printing xml with degrees of presets";
+    const char *testname = "xmlparser_5_0";
+    const char *infile = "xmlparser_5_0_in.xml";
+    int retVal = 0;
+
+    const char *xmltext = NULL;
+
+    readFile(infile,&xmltext);
+
+    const char *expected = "\
+run.tool.about Press Simulate to view results.\n\
+run.tool.command tclsh @tool/fermi.tcl @driver\n\
+run.input.number(Ef).about.label Fermi Level\n\
+run.input.number(Ef).about.description Energy at center of distribution.\n\
+run.input.number(Ef).units eV\n\
+run.input.number(Ef).min -10eV\n\
+run.input.number(Ef).max 10eV\n\
+run.input.number(Ef).default 0eV\n\
+run.input.number(Ef).current 0eV\n";
+
+    const char *received = NULL;
+
+    Rp_ParserXml *p = NULL;
+
+    p = Rp_ParserXmlCreate();
+
+    Rp_ParserXmlParse(p, xmltext);
+
+    received = Rp_ParserXmlPathVal(p);
+
+
+    if (strcmp(expected,received) != 0) {
+        printf("Error: %s\n", testname);
+        printf("\t%s\n", desc);
+        printf("\texpected %zu bytes: \"%s\"\n",strlen(expected), expected);
+        printf("\treceived %zu bytes: \"%s\"\n",strlen(received), received);
+        retVal = 1;
+    }
+
+    if (p) {
+        Rp_ParserXmlDestroy(&p);
+    }
+
+    return retVal;
+}
+
+// FIXME: test what happens when parser sees self closing tag <tag/>
+// FIXME: test get function
+// FIXME: test put function
+// FIXME: look into why Rp_ParserXmlPathVal hits some nodes twice in gdb
+
+int main()
+{
+    xmlparser_0_0();
+    xmlparser_1_0();
+    xmlparser_2_0();
+    xmlparser_3_0();
+    xmlparser_4_0();
+    xmlparser_5_0();
 
     return 0;
Index: /trunk/src/core/RpSimpleBuffer.h
===================================================================
--- /trunk/src/core/RpSimpleBuffer.h	(revision 1559)
+++ /trunk/src/core/RpSimpleBuffer.h	(revision 1560)
@@ -81,4 +81,5 @@
     SimpleBuffer     operator+(const SimpleBuffer& b) const;
     SimpleBuffer<T>& operator+=(const SimpleBuffer<T>& b);
+    T operator[](size_t offset);
     virtual ~SimpleBuffer();
 
@@ -241,4 +242,16 @@
 
 /**
+ * Operator []
+ * @param index into the buffer
+ */
+template<class T>
+T
+SimpleBuffer<T>::operator[](size_t idx)
+{
+    return (_buf+idx);
+}
+
+
+/**
  * Destructor
  */
Index: /trunk/src/objects/RpAccessor.h
===================================================================
--- /trunk/src/objects/RpAccessor.h	(revision 1559)
+++ /trunk/src/objects/RpAccessor.h	(revision 1560)
@@ -71,4 +71,8 @@
 Accessor<const char *>::operator() (const char *val)
 {
+    if (val == NULL) {
+        return;
+    }
+
     size_t len = strlen(val);
     char *tmp = new char[len+1];
Index: /trunk/src/objects/RpArray1D.cc
===================================================================
--- /trunk/src/objects/RpArray1D.cc	(revision 1559)
+++ /trunk/src/objects/RpArray1D.cc	(revision 1560)
@@ -180,5 +180,5 @@
 
 const char *
-Array1D::xml()
+Array1D::xml(size_t indent, size_t tabstop)
 {
     return "";
Index: /trunk/src/objects/RpArray1D.h
===================================================================
--- /trunk/src/objects/RpArray1D.h	(revision 1559)
+++ /trunk/src/objects/RpArray1D.h	(revision 1560)
@@ -41,5 +41,5 @@
     static const char type[];
 
-    const char *xml(void);
+    const char *xml(size_t indent, size_t tabstop);
     const int is(void) const;
 
Index: /trunk/src/objects/RpAxisMarker.cc
===================================================================
--- /trunk/src/objects/RpAxisMarker.cc	(revision 1559)
+++ /trunk/src/objects/RpAxisMarker.cc	(revision 1560)
@@ -139,14 +139,18 @@
 
 const char *
-AxisMarker::xml()
+AxisMarker::xml(size_t indent, size_t tabstop)
 {
+    size_t l1width = indent + tabstop;
+    const char *sp = "";
+
     _tmpBuf.clear();
 
     _tmpBuf.appendf(
-"        <marker>\n\
-            <at>%g</at>\n\
-            <label>%s</label>\n\
-            <style>%s</style>\n\
-        <marker>\n",_at,label(),_style);
+"%6$*4$s<marker>\n\
+%6$*5$s<at>%1$g</at>\n\
+%6$*5$s<label>%2$s</label>\n\
+%6$*5$s<style>%3$s</style>\n\
+%6$*4$s<marker>\n",
+        _at,label(),_style,indent,l1width,sp);
 
     _tmpBuf.append("\0",1);
Index: /trunk/src/objects/RpAxisMarker.h
===================================================================
--- /trunk/src/objects/RpAxisMarker.h	(revision 1559)
+++ /trunk/src/objects/RpAxisMarker.h	(revision 1560)
@@ -39,5 +39,5 @@
         double at (void) const;
 
-        const char *xml();
+        const char *xml(size_t indent, size_t tabstop);
         const int is(void) const;
 
Index: /trunk/src/objects/RpBoolean.cc
===================================================================
--- /trunk/src/objects/RpBoolean.cc	(revision 1559)
+++ /trunk/src/objects/RpBoolean.cc	(revision 1560)
@@ -65,6 +65,10 @@
 
 const char *
-Boolean::xml()
+Boolean::xml(size_t indent, size_t tabstop)
 {
+    size_t l1width = indent + tabstop;
+    size_t l2width = indent + (2*tabstop);
+    const char *sp = "";
+
     Path p(path());
     _tmpBuf.clear();
@@ -73,13 +77,13 @@
 
     _tmpBuf.appendf(
-"<boolean id=\"%s\">\n\
-    <about>\n\
-        <label>%s</label>\n\
-        <description>%s</description>\n\
-    </about>\n\
-    <default>%i</default>\n\
-    <current>%i</current>\n\
-</boolean>",
-       p.id(),label(),desc(),def(),cur());
+"%9$*6$s<boolean id=\"%1$s\">\n\
+%9$*7$s<about>\n\
+%9$*8$s<label>%2$s</label>\n\
+%9$*8$s<description>%3$s</description>\n\
+%9$*7$s</about>\n\
+%9$*7$s<default>%4$i</default>\n\
+%9$*7$s<current>%5$i</current>\n\
+%9$*6$s</boolean>",
+       p.id(),label(),desc(),def(),cur(),indent,l1width,l2width,sp);
 
     return _tmpBuf.bytes();
Index: /trunk/src/objects/RpBoolean.h
===================================================================
--- /trunk/src/objects/RpBoolean.h	(revision 1559)
+++ /trunk/src/objects/RpBoolean.h	(revision 1560)
@@ -34,5 +34,5 @@
         Accessor<int> cur;
 
-        const char *xml();
+        const char *xml(size_t indent, size_t tabstop);
         const int is() const;
 };
Index: /trunk/src/objects/RpChoice.cc
===================================================================
--- /trunk/src/objects/RpChoice.cc	(revision 1559)
+++ /trunk/src/objects/RpChoice.cc	(revision 1560)
@@ -150,16 +150,21 @@
 
 const char *
-Choice::xml()
-{
+Choice::xml(size_t indent, size_t tabstop)
+{
+    size_t l1width = indent + tabstop;
+    size_t l2width = indent + (2*tabstop);
+    size_t l3width = indent + (3*tabstop);
+    const char *sp = "";
+
     Path p(path());
     _tmpBuf.clear();
 
     _tmpBuf.appendf(
-"<choice id='%s'>\n\
-    <about>\n\
-        <label>%s</label>\n\
-        <description>%s</description>\n\
-    </about>\n",
-       p.id(),label(),desc());
+"%7$*4$s<choice id='%1$s'>\n\
+%7$*5$s<about>\n\
+%7$*6$s<label>%2$s</label>\n\
+%7$*6$s<description>%3$s</description>\n\
+%7$*5$s</about>\n",
+       p.id(),label(),desc(),indent,l1width,l2width,sp);
 
     Rp_ChainLink *l = NULL;
@@ -168,20 +173,20 @@
         option *op = (option *)Rp_ChainGetValue(l);
         _tmpBuf.appendf(
-"    <option>\n\
-        <about>\n\
-            <label>%s</label>\n\
-            <description>%s</description>\n\
-        </about>\n\
-        <value>%s</value>\n\
-    </option>\n",
-           op->label(),op->desc(),op->val());
+"%7$*4$s<option>\n\
+%7$*5$s<about>\n\
+%7$*6$s<label>%1$s</label>\n\
+%7$*6$s<description>%2$s</description>\n\
+%7$*5$s</about>\n\
+%7$*5$s<value>%3$s</value>\n\
+%7$*4$s</option>\n",
+           op->label(),op->desc(),op->val(),l1width,l2width,l3width,sp);
         l = Rp_ChainNextLink(l);
     }
 
     _tmpBuf.appendf(
-"    <default>%s</default>\n\
-    <current>%s</current>\n\
-</choice>",
-       def(),cur());
+"%5$*4$s<default>%1$s</default>\n\
+%5$*4$s<current>%2$s</current>\n\
+%5$*3$s</choice>",
+       def(),cur(),indent,l1width,sp);
 
     return _tmpBuf.bytes();
Index: /trunk/src/objects/RpChoice.h
===================================================================
--- /trunk/src/objects/RpChoice.h	(revision 1559)
+++ /trunk/src/objects/RpChoice.h	(revision 1560)
@@ -41,5 +41,5 @@
         Choice& delOption ( const char *label);
 
-        const char *xml();
+        const char *xml(size_t indent, size_t tabstop);
         const int is() const;
 
Index: /trunk/src/objects/RpCurve.cc
===================================================================
--- /trunk/src/objects/RpCurve.cc	(revision 1559)
+++ /trunk/src/objects/RpCurve.cc	(revision 1560)
@@ -259,6 +259,10 @@
 
 const char *
-Curve::xml()
-{
+Curve::xml(size_t indent, size_t tabstop)
+{
+    size_t l1width = indent + tabstop;
+    size_t l2width = indent + (2*tabstop);
+    const char *sp = "";
+
     Path p(path());
 
@@ -267,14 +271,17 @@
 
     const double *dataArr[dims()];
+    const char *type = propstr("type");
 
     _tmpBuf.clear();
 
     _tmpBuf.appendf(
-"<curve id=\"%s\">\n\
-    <about>\n\
-        <group>%s</group>\n\
-        <label>%s</label>\n\
-        <description>%s</description>\n\
-    </about>\n", p.id(),group(),label(),desc());
+"%9$*6$s<curve id=\"%1$s\">\n\
+%9$*7$s<about>\n\
+%9$*8$s<group>%2$s</group>\n\
+%9$*8$s<label>%3$s</label>\n\
+%9$*8$s<description>%4$s</description>\n\
+%9$*8$s<type>%5$s</type>\n\
+%9$*7$s</about>\n",
+        p.id(),group(),label(),desc(),type,indent,l1width,l2width,sp);
 
     for (size_t dim=0; dim < dims(); dim++) {
@@ -283,15 +290,15 @@
         dataArr[dim] = tmpAxis->data();
         _tmpBuf.appendf(
-"    <%s>\n\
-        <label>%s</label>\n\
-        <description>%s</description>\n\
-        <units>%s</units>\n\
-        <scale>%s</scale>\n\
-    </%s>\n",
+"%8$*6$s<%1$s>\n\
+%8$*7$s<label>%2$s</label>\n\
+%8$*7$s<description>%3$s</description>\n\
+%8$*7$s<units>%4$s</units>\n\
+%8$*7$s<scale>%5$s</scale>\n\
+%8$*6$s</%1$s>\n",
         tmpAxis->name(), tmpAxis->label(), tmpAxis->desc(),
-        tmpAxis->units(), tmpAxis->scale(), tmpAxis->name());
-    }
-
-    _tmpBuf.append("    <component>\n        <xy>\n");
+        tmpAxis->units(), tmpAxis->scale(),l1width,l2width,sp);
+    }
+
+    _tmpBuf.appendf("%3$*1$s<component>\n%3$*2$s<xy>\n",l1width,l2width,sp);
     for (size_t idx=0; idx < nmemb; idx++) {
         for(size_t dim=0; dim < dims(); dim++) {
@@ -300,6 +307,6 @@
         _tmpBuf.append("\n",1);
     }
-    _tmpBuf.append("        </xy>\n    </component>\n</curve>");
-    _tmpBuf.append("\0",1);
+    _tmpBuf.appendf("%4$*3$s</xy>\n%4$*2$s</component>\n%4$*1$s</curve>",
+        indent, l1width, l2width, sp);
 
     return _tmpBuf.bytes();
Index: /trunk/src/objects/RpCurve.h
===================================================================
--- /trunk/src/objects/RpCurve.h	(revision 1559)
+++ /trunk/src/objects/RpCurve.h	(revision 1560)
@@ -48,5 +48,5 @@
         size_t dims() const;
 
-        const char *xml();
+        const char *xml(size_t indent, size_t tabstop);
         const int is() const;
 
Index: /trunk/src/objects/RpHistogram.cc
===================================================================
--- /trunk/src/objects/RpHistogram.cc	(revision 1559)
+++ /trunk/src/objects/RpHistogram.cc	(revision 1560)
@@ -315,6 +315,10 @@
 
 const char *
-Histogram::xml()
-{
+Histogram::xml(size_t indent, size_t tabstop)
+{
+    size_t l1width = indent + tabstop;
+    size_t l2width = indent + (2*tabstop);
+    const char *sp = "";
+
     Path p(path());
 
@@ -327,10 +331,11 @@
 
     _tmpBuf.appendf(
-"<histogram id=\"%s\">\n\
-    <about>\n\
-        <group>%s</group>\n\
-        <label>%s</label>\n\
-        <description>%s</description>\n\
-    </about>\n", p.id(),group(),label(),desc());
+"%8$*5$s<histogram id=\"%1$s\">\n\
+%8$*6$s<about>\n\
+%8$*7$s<group>%2$s</group>\n\
+%8$*7$s<label>%3$s</label>\n\
+%8$*7$s<description>%4$s</description>\n\
+%8$*6$s</about>\n",
+        p.id(),group(),label(),desc(),indent,l1width,l2width,sp);
 
     for (size_t dim=0; dim < dims(); dim++) {
@@ -342,11 +347,11 @@
         }
         _tmpBuf.appendf(
-"    <%s>\n\
-        <label>%s</label>\n\
-        <description>%s</description>\n\
-        <units>%s</units>\n\
-        <scale>%s</scale>\n",
+"%8$*6$s<%1$s>\n\
+%8$*7$s<label>%2$s</label>\n\
+%8$*7$s<description>%3$s</description>\n\
+%8$*7$s<units>%4$s</units>\n\
+%8$*7$s<scale>%5$s</scale>\n",
         tmpAxis->name(), tmpAxis->label(), tmpAxis->desc(),
-        tmpAxis->units(), tmpAxis->scale());
+        tmpAxis->units(), tmpAxis->scale(),l1width,l2width,sp);
 
         if (_markerList != NULL) {
@@ -355,13 +360,13 @@
                 AxisMarker *m = (AxisMarker *) Rp_ChainGetValue(l);
                 if (strcmp(tmpAxis->name(),m->axisName()) == 0) {
-                    _tmpBuf.append(m->xml());
+                    _tmpBuf.append(m->xml(indent+tabstop,tabstop));
                 }
                 l = Rp_ChainNextLink(l);
             }
         }
-        _tmpBuf.appendf("    </%s>\n",tmpAxis->name());
-    }
-
-    _tmpBuf.append("    <component>\n        <xhw>\n");
+        _tmpBuf.appendf("%3$*2$s</%1$s>\n",tmpAxis->name(),l1width,sp);
+    }
+
+    _tmpBuf.appendf("%3$*1$s<component>\n%3$*2$s<xhw>\n",l1width,l2width,sp);
     for (size_t idx=0; idx < nmemb; idx++) {
         for (size_t dim=0; dim < dims(); dim++) {
@@ -370,6 +375,6 @@
         _tmpBuf.append("\n",1);
     }
-    _tmpBuf.append("        </xhw>\n    </component>\n</curve>");
-    _tmpBuf.append("\0",1);
+    _tmpBuf.appendf("%4$*3$s</xhw>\n%4$*2$s</component>\n%4$*1$s</curve>",
+        indent,l1width,l2width,sp);
 
     return _tmpBuf.bytes();
Index: /trunk/src/objects/RpHistogram.h
===================================================================
--- /trunk/src/objects/RpHistogram.h	(revision 1559)
+++ /trunk/src/objects/RpHistogram.h	(revision 1560)
@@ -73,5 +73,5 @@
         size_t nbins(void) const;
 
-        const char *xml();
+        const char *xml(size_t indent, size_t tabstop);
         const int is(void) const;
 
